.section .data                                        
	piso_heap : .quad 0
	teto_heap : .quad 0
	str1: .string "NAO EXISTE ESPACO ALOCADO!\n"
	str2: .string "#"
	str3: .string "-"
	str4: .string "*"
	str5: .string "INICIANDO O ALOCADOR!\n"
	str6: .string "ENTRADA INVALIDA!\n"
	pula_Linha: .string "\n"

	flag: .string  "%d"


.section .bss
	.equ ALOCADOR, 1040
	.equ LIVRE, 1
	.equ OCUPADO, 0

.section .text
	.globl iniciaAlocador
	.globl finalizaAlocador
	.globl aloca_espaco
	.globl meuMalloc
	.globl arruma_heap
	.globl meuFree
	.globl imprimeMapa
#---------------------------------------------------------------------#

iniciaAlocador:
	pushq %rbp
	movq %rsp, %rbp
	
	movq $str5, %rdi
	call printf

	movq $0, %rdi			# sbrk(0)
	movq $12,%rax
	syscall

	movq %rax, piso_heap	#piso_heap = inicio_heap
	addq $ALOCADOR, %rax
	movq %rax, teto_heap	#teto_heap = piso + alocador

	movq %rax, %rdi			#aloca o espaco reservado
	movq $12, %rax
	syscall	
	
	movq piso_heap, %rax
	movq $LIVRE, (%rax)		#deixa livre o primeiro slot de memoria
	movq $ALOCADOR, %r13
	subq $16, %r13
	movq %r13, 8(%rax)		#disponibiliza o tamanho do espaco alocado
	
	popq %rbp
	ret
#---------------------------------------------------------------------#

finalizaAlocador:
	pushq %rbp
	movq %rsp, %rbp

	movq piso_heap, %rax
	cmpq $0, %rax
	je fim_if
		movq %rax, %rdi		
		movq $12, %rax		#coloca a posicao da heap de volta no começo
		syscall

		movq $0, teto_heap	#zera o topo e o piso da heap
		movq $0, piso_heap
		jmp fim_if
	fim_if:
	
	popq %rbp
	ret
#---------------------------------------------------------------------#

aloca_espaco:
	pushq %rbp
	movq %rsp, %rbp
	
		movq %rdi, %rax
		addq $16, %rax
		addq %rax, teto_heap
		movq teto_heap, %rdi
		movq $12, %rax
		syscall

	popq %rbp
	ret
#---------------------------------------------------------------------#

meuMalloc:
	pushq %rbp
	movq %rsp, %rbp
	subq $8, %rsp					#aloca espaco para endr	
	
	movq %rdi, %r12					#r12 = ponteiro alocado
	cmpq $0, %r12
	jne fim_pegadinha_if			#quando tam_alloc == 0 return
		addq $8, %rsp
		popq %rbp
		ret
	fim_pegadinha_if:
	
	movq piso_heap, %rax
	cmpq $0, %rax
	jne fim_if_aloca_mem	
		call iniciaAlocador
	fim_if_aloca_mem:
	movq piso_heap, %rbx

	movq %rbx,-8(%rbp)
	movq -8(%rbp), %rbx				# endr = -8(rbp)
	
	movq %r12, %r11
	addq $16, %r11

	while_loop_aloca_mem:
	cmpq teto_heap, %rbx			#rbx = endr
	jg fim_while_aloca_mem
		cmpq $LIVRE, (%rbx)
		jne fim_if_while_aloca_mem
			cmpq %r11, 8(%rbx)
			jle else_if_aloca_mem2
				addq $16, %r12		#8(endr) -= tam_alloc + 16
				subq %r12, 8(%rbx)				
				movq 8(%rbx), %r13
				subq $16, %r12				
				addq $16, %r13		#endr += 8(endr) + 16
				addq %r13, %rbx	
				movq $OCUPADO, (%rbx)
				movq %r12, 8(%rbx)				
			jmp fim_if_aloca_mem2
			else_if_aloca_mem2:					
				movq teto_heap, %rbx
				movq %r12, %r15
				pushq %r12
				call aloca_espaco
				popq %r12
				movq $OCUPADO,(%rbx)
				movq %r15, 8(%rbx)
				
				movq %rbx, %rcx
				addq %r12, %rcx
				addq $16, %rcx
				movq %rcx, teto_heap
			jmp fim_if_aloca_mem2
			fim_if_aloca_mem2:
			jmp fim_while_aloca_mem	
		fim_if_while_aloca_mem:
		addq $16, 8(%rbx)
		movq 8(%rbx), %r10
		addq %r10, %rbx		
		jmp while_loop
	fim_while_aloca_mem:	
			
	movq %rbx, %rax					#retorna endr + 16
	addq $16, %rax	
	
	addq $8, %rsp
	popq %rbp
	ret
#---------------------------------------------------------------------#

arruma_heap:
	pushq %rbp
	movq %rsp, %rbp
	subq $16, %rsp	

	movq piso_heap, %r10
	movq %r10, -8(%rbp)	#endr_ant = piso_heap
	movq -8(%rbp), %rax
	
	movq piso_heap, %rbx
	addq $16, %rbx
	addq 8(%rax), %rbx
	movq %rbx, -16(%rbp)		#endr = piso_heap + tam_piso + 16

	while_arruma_heap:
	cmpq teto_heap, %rbx
	jge fim_while_arruma_heap
		cmpq $1, (%rbx)
		jne else_if_arruma_heap
		cmpq $1, (%rax)
		jne else_if_arruma_heap
			movq 8(%rbx), %r10

			addq %r10, 8(%rax)
			addq $16, 8(%rax)

		jmp fim_if_arruma_heap
		else_if_arruma_heap:
			movq %rbx, %rax
		jmp fim_if_arruma_heap
	fim_if_arruma_heap:
	
	movq 8(%rbx), %r13
	addq $16, %r13
	addq %r13, %rbx

	jmp while_arruma_heap
	fim_while_arruma_heap: 

	addq $16, %rsp
	popq %rbp
	ret
#---------------------------------------------------------------------#

meuFree:
	pushq %rbp
	movq %rsp, %rbp

	movq %rdi, %rbx
	movq $LIVRE, -16(%rbx)
	call arruma_heap	

	popq %rbp
	ret
#---------------------------------------------------------------------#

imprimeMapa:
	pushq %rbp
	movq %rsp, %rbp
	subq $16, %rsp		#coloca i na pilha

	movq piso_heap, %rbx
	movq teto_heap, %r11
	cmpq $0, %rbx
	jne fim_if_mapa	
		movq $str1, %rdi
		call printf
		addq $16, %rsp
		popq %rbp
		ret		 
	fim_if_mapa:
	movq %rbx,-16(%rbp)
	movq -16(%rbp), %rbx			# endr = -8(rbp)
	while_loop:
	cmpq teto_heap, %rbx
	jge fim_while_loop		
		movq $0, -8(%rbp)		#i = 0
		movq -8(%rbp), %r12		#r12 = i
		for_cabecalho:
		cmpq $16, %r12
		jge fim_for_cabecalho
			movq $str2, %rdi
			call printf
			addq $1, %r12
			jmp for_cabecalho
		fim_for_cabecalho:
			
			#movq $flag, %rdi
			#movq 8(%rbx), %rsi
			#call printf
		
		cmpq $LIVRE, (%rbx)
		jne else_if_while
			movq $0, -8(%rbp)		#i = 0
			movq -8(%rbp), %r12		#r12 = i
			for_livre:
			cmpq 8(%rbx), %r12
			jge fim_for_livre
				movq $str3, %rdi
				call printf
				addq $1, %r12
				jmp for_livre
			fim_for_livre:
			jmp fim_if_while

		else_if_while:
			movq $0, -8(%rbp)		#i = 0
			movq -8(%rbp), %r12		#r12 = i
			for_ocupado:
			cmpq 8(%rbx), %r12
			jge fim_for_ocupado
				movq $str4, %rdi
				call printf
				addq $1, %r12
				jmp for_ocupado
			fim_for_ocupado:
			jmp fim_if_while
		
		fim_if_while:
		movq 8(%rbx), %r13
		addq $16, %r13
		addq %r13, %rbx

		jmp while_loop
	
	fim_while_loop:
	
	movq $pula_Linha, %rdi
	call printf

	addq $16, %rsp
	popq %rbp
	ret
#---------------------------------------------------------------------#
